function [W1]= OptNoIRSW(M,P,h_au,h_ae,var_u,var_e,var_id,rho,var_si,var_an,h_ue)
%% Ԥ


var_au=var_u+var_id/rho+var_si;
var_ae=var_e+(abs(h_ue))^2*var_an;
F_au=h_au*h_au';
F_ae=h_ae*h_ae';

%% Ż

cvx_begin quiet
variable mu1
variable W(M,M) hermitian
maximize(mu1*var_au+real(trace(F_au*W)))
subject to 
real(trace(W))<=mu1*P;
mu1*var_ae+real(trace(F_ae*W))<=1;
0<=(1-rho)*real(trace(F_au*W));
W==hermitian_semidefinite(M);
mu1>=0;
cvx_end
W1=W/mu1;


end