%% 
% ͬ书
% ʼʱ12-30 
% ʱ12-31
%%
close all;
clear;
clc;
warning('off');
%% ʼ
M = 8;                  %߸
N = 64;                 %Ԫ
P=inputdB(30);          %
P_cir=inputdB(-75);     %·Ĺ
var_si=inputdB(-75);    %ԸŹ
var_id=inputdB(-75);    %·
var_u=inputdB(-55);     %û
var_e=inputdB(-55);     %߽
var_AN=inputdB(-20);    %ʼ˹
rho = 0.5;             %ʷ
nbit=2;
b=0.003;  %N_EH-para
a=2100;
Em=0.02;
%% ŵģ
r_con=[];r_mrt=[];r_NoIRS=[];r_dis1=[];r_ran=[];r_dis2=[];

[G,h_iu,h_ie,h_ue,h_au,h_ae]=GenChannel(N,M);
Theta_rand=zeros(N,N);
for i=1:N
Theta_rand(i,i)=exp(rand(1)*2*pi*1j);
end
disp('Begin Loop');
rho_all=0.1:0.1:0.9;
for i=1:9
%%  Ԥ
rho=rho_all(i);
%%  Ż
%% 
    tic;
     disp([' Loop  ', num2str(i), '  running...']);
%% con  
    r1=OptCon(M,N,G,P,rho,Theta_rand,h_iu,h_ie,h_ue,h_au,h_ae,var_si,var_u,var_e,var_id,var_AN,a,b,Em);
    r_con=[r_con,r1];  
%% dis  -2
    r6=OptDis(M,N,G,P,rho,Theta_rand,h_iu,h_ie,h_ue,h_au,h_ae,var_si,var_u,var_e,var_id,var_AN,a,b,Em,4);
    r_dis1=[r_dis1,r6];  
%% dis -  3
    r7=OptDis(M,N,G,P,rho,Theta_rand,h_iu,h_ie,h_ue,h_au,h_ae,var_si,var_u,var_e,var_id,var_AN,a,b,Em,2);
    r_dis2=[r_dis2,r7];  
%% MRT   
    [r3]=OptMrt(M,N,G,P,rho,Theta_rand,h_iu,h_ie,h_ue,h_au,h_ae,var_si,var_u,var_e,var_id,var_AN,a,b,Em);
    r_mrt=[r_mrt,r3];
%% No_IRS 
    [r4]=OptNoIRS(rho,M,P,h_au,h_ae,var_u,var_e,var_id,var_si,var_AN,h_ue,a,b,Em);
    r_NoIRS=[r_NoIRS,r4];
%% random
    r8=OptRan(M,N,G,P,rho,Theta_rand,h_iu,h_ie,h_ue,h_au,h_ae,var_si,var_u,var_e,var_id,var_AN,a,b,Em);
    r_ran=[r_ran,r8]; 
 
    toc;
end   
disp('End Loop');
%%


grid on;
plot(rho_all,fliplr(r_con),'-r','Marker', 'p', 'LineWidth', 1.5, 'MarkerSize', 10);
hold on;
plot(rho_all,fliplr(r_dis1),'-b','Marker', 's', 'LineWidth', 1.5, 'MarkerSize', 10);  %bit=2
hold on;
plot(rho_all,fliplr(r_dis2),'-k','Marker', '*', 'LineWidth', 1.5, 'MarkerSize', 10);  %bit=3
hold on;
plot(rho_all,fliplr(r_ran), 'g','Marker', 'd', 'LineWidth', 1.5, 'MarkerSize', 10);
hold on;
plot(rho_all,fliplr(r_mrt),'-c','Marker', 'o', 'LineWidth', 1.5, 'MarkerSize', 10);
hold on;
plot(rho_all,fliplr(r_NoIRS),'m','Marker', '<', 'LineWidth', 1.5, 'MarkerSize', 10);

legend('Continue phase shift ({\it L=\infty})','Disperse phase shift (\it L= 4 )','Disperse phase shift (\it L= 2 )','Random phase shift','MRT','Without IRS');
xlabel('{\it{\rho}}','FontSize',12);%,'Fontname', 'Times New Roman'
ylabel('Secrecy Rate (bps/Hz)','FontSize',12);